package org.wfc.omada.api.device.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * PlanUpgradeModelList
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:26:25.576+08:00[Asia/Shanghai]")

public class PlanUpgradeModelList   {
  @JsonProperty("modelTypeInfo")
  private ModelTypeInfoOpenApiVo modelTypeInfo;

  @JsonProperty("currentVersion")
  @Valid
  private List<String> currentVersion = null;

  @JsonProperty("status")
  private Integer status;

  @JsonProperty("upgradeStatus")
  private Integer upgradeStatus;

  public PlanUpgradeModelList modelTypeInfo(ModelTypeInfoOpenApiVo modelTypeInfo) {
    this.modelTypeInfo = modelTypeInfo;
    return this;
  }

  /**
   * Get modelTypeInfo
   * @return modelTypeInfo
  */
  @ApiModelProperty(value = "")

  @Valid

  public ModelTypeInfoOpenApiVo getModelTypeInfo() {
    return modelTypeInfo;
  }

  public void setModelTypeInfo(ModelTypeInfoOpenApiVo modelTypeInfo) {
    this.modelTypeInfo = modelTypeInfo;
  }

  public PlanUpgradeModelList currentVersion(List<String> currentVersion) {
    this.currentVersion = currentVersion;
    return this;
  }

  public PlanUpgradeModelList addCurrentVersionItem(String currentVersionItem) {
    if (this.currentVersion == null) {
      this.currentVersion = new ArrayList<>();
    }
    this.currentVersion.add(currentVersionItem);
    return this;
  }

  /**
   * Model version list, software version, such as \"2.5.0 Build 20190118 Rel. 64821\"
   * @return currentVersion
  */
  @ApiModelProperty(value = "Model version list, software version, such as \"2.5.0 Build 20190118 Rel. 64821\"")


  public List<String> getCurrentVersion() {
    return currentVersion;
  }

  public void setCurrentVersion(List<String> currentVersion) {
    this.currentVersion = currentVersion;
  }

  public PlanUpgradeModelList status(Integer status) {
    this.status = status;
    return this;
  }

  /**
   * Model critical status should be a value as follows: 0: good; 1: critical
   * @return status
  */
  @ApiModelProperty(value = "Model critical status should be a value as follows: 0: good; 1: critical")


  public Integer getStatus() {
    return status;
  }

  public void setStatus(Integer status) {
    this.status = status;
  }

  public PlanUpgradeModelList upgradeStatus(Integer upgradeStatus) {
    this.upgradeStatus = upgradeStatus;
    return this;
  }

  /**
   * Model upgrade status should be a value as follows: 0: up-to-date; 1: new Version Available
   * @return upgradeStatus
  */
  @ApiModelProperty(value = "Model upgrade status should be a value as follows: 0: up-to-date; 1: new Version Available")


  public Integer getUpgradeStatus() {
    return upgradeStatus;
  }

  public void setUpgradeStatus(Integer upgradeStatus) {
    this.upgradeStatus = upgradeStatus;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PlanUpgradeModelList planUpgradeModelList = (PlanUpgradeModelList) o;
    return Objects.equals(this.modelTypeInfo, planUpgradeModelList.modelTypeInfo) &&
        Objects.equals(this.currentVersion, planUpgradeModelList.currentVersion) &&
        Objects.equals(this.status, planUpgradeModelList.status) &&
        Objects.equals(this.upgradeStatus, planUpgradeModelList.upgradeStatus);
  }

  @Override
  public int hashCode() {
    return Objects.hash(modelTypeInfo, currentVersion, status, upgradeStatus);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PlanUpgradeModelList {\n");
    
    sb.append("    modelTypeInfo: ").append(toIndentedString(modelTypeInfo)).append("\n");
    sb.append("    currentVersion: ").append(toIndentedString(currentVersion)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    upgradeStatus: ").append(toIndentedString(upgradeStatus)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

